<script lang="ts">
import Vue from "vue";
import { SlpTypography } from "slippers-ui";

import CloseIcon from "../../assets/close.vue";
import SlpSearchSuggestions from "./search-suggestions.vue";
import { search, SEARCH_TYPE, SearchBody } from "../../services/search.service";
import { debounce, DebouncedFunc } from "lodash-es";

/**
 * Component that contains the main search input and the suggestion's implementation
 */
export default Vue.extend({
  name: "SlpSearchContent",
  components: {
    SlpTypography,
    CloseIcon,
    SlpSearchSuggestions,
  },
  data() {
    return {
      searchText: "",
      suggestions: [],
      suggestionDebounce: (() => ({})) as DebouncedFunc<any>,
      searchType: SEARCH_TYPE.MARKETING,
    };
  },
  created() {
    this.suggestionDebounce = debounce(this.getSuggestions, 100);
  },
  beforeDestroy() {
    this.suggestionDebounce?.cancel();
  },
  mounted() {
    this.$nextTick(() => (this.$refs.searchInput as any).focus());
  },
  methods: {
    onSuggestionSelect(suggestion: string) {
      this.searchText = suggestion;
      this.onSearch(suggestion);
    },
    onSearch(searchText: string) {
      this.$emit("search", searchText);
    },
    /**
     * This method do a search with the searchTerm that the user is typing and gets and spelling result that is added to the first position to show the spelling
     * suggestion as the first position of the array
     */
    getSuggestions() {
      if (this.searchText.length < 3) {
        return;
      }

      const searchBody: SearchBody = new SearchBody({
        q: this.searchText,
        spelling: "always",
        per_page: 10,
      });

      search(searchBody, this.searchType).then((res) => {
        this.suggestions = res.records.page;
        if (res.info.page.spelling_suggestion) {
          const spelling = { title: res.info.page.spelling_suggestion.text };
          this.suggestions = [spelling, ...this.suggestions] as never[];
        }
      });
    },
    cleanSearch() {
      this.searchText = "";
    },
  },
});
</script>

<template>
  <div class="be-nav-search-content">
    <div class="be-nav-search-content__input slp-mb-16">
      <input
        type="text"
        v-model="searchText"
        placeholder="Search"
        v-on:keyup.enter="onSearch(searchText)"
        @input="suggestionDebounce"
        ref="searchInput"
      />
      <CloseIcon
        v-if="searchText.length"
        class="be-nav-search-content__input--close"
        @click.native="cleanSearch"
        fill="#171321"
      />
    </div>
    <div class="slp-mb-48">
      <SlpTypography class="slp-mb-8" tag="div" variant="body3">
        To search repositories and projects, login to
        <a
          href="https://gitlab.com/users/sign_in/"
          target="_blank"
          data-ga-name="search login"
          data-ga-location="search"
          class="slp-color-text-link-100"
          >gitlab.com</a
        >.
      </SlpTypography>
    </div>
    <SlpSearchSuggestions
      :search-suggestions="suggestions"
      @suggestionSelect="onSuggestionSelect"
    />
  </div>
</template>

<style lang="scss">
.be-nav-search-content {
  padding: $spacing-24;

  @media (max-width: $breakpoint-lg) {
    padding: $spacing-8;
  }

  &__input {
    width: 100%;
    position: relative;

    input {
      -webkit-appearance: none;
      -webkit-border-radius: 0;
      border-radius: 0;
      width: calc(100% - 8px);
      font-size: $text-heading-3;
      border: 0;
      border-bottom: $color-surface-300 solid 1px;
      color: $color-text-200;

      &::placeholder {
        color: $color-text-100;
      }

      &:focus {
        outline: none;
      }

      @media (max-width: $breakpoint-lg) {
        font-size: $text-heading-5-mobile;
        caret-color: $color-surface-700 !important;
      }
    }

    &--close {
      position: absolute;
      right: $spacing-16;
      top: 20px;
      cursor: pointer;

      @media (max-width: $breakpoint-md) {
        top: 12px;
      }
    }
  }
}
</style>
